package com.docus.server.ws.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.docus.core.util.DateUtil;
import com.docus.core.util.Func;
import com.docus.server.collect.infrastructure.dao.CollectTypeEnum;
import com.docus.server.collect.infrastructure.dao.StateEnum;
import com.docus.server.collect.infrastructure.dao.TaskOriginalMessage;
import com.docus.server.collect.infrastructure.mapper.TaskOriginalMessageMapper;
import com.docus.server.ws.ITaskOriginalMessageService;
import com.docus.server.ws.convert.TaskOriginalMessageConverter;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

@Service
public class TaskOriginalMessageServiceImpl extends ServiceImpl<TaskOriginalMessageMapper, TaskOriginalMessage> implements ITaskOriginalMessageService {
    @Resource
    private TaskOriginalMessageConverter converter;

    /**
     * 新增 ws xml 原始报文
     */
    @Transactional(rollbackFor = Exception.class)
    @Override
    public Long insertTaskOriginalMessage(Object json, String xml, CollectTypeEnum collectType) {
        TaskOriginalMessage taskOriginalMessage = converter.toConvertTaskOriginalMessageDO(json, xml, collectType);
        super.save(taskOriginalMessage);
        return taskOriginalMessage.getId();
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void updateTaskOriginalMessage(Long id, Object json, StateEnum stateEnum) {
        if (null == id) {
            return;
        }
        TaskOriginalMessage taskOriginalMessage = super.getById(id);
        if (Func.isNotEmpty(taskOriginalMessage)) {
            taskOriginalMessage.setJsonStr(json);
            taskOriginalMessage.setUpdateTime(DateUtil.now());
            taskOriginalMessage.setState(stateEnum);
            super.updateById(taskOriginalMessage);
        }
    }
}
